// cgp_csv.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>
#include <string.h>
using namespace std;

void makeFitnessCSV() {
	/*
	g.generation=199999
	g.parentPacketReceived_fitness=14500
	g.parentDataReady_fitness=14500
	g.parentPacketExpired_fitness=14500
	g.bestInGeneration=145027
	g.bestFitness=6000
	g.validatedFitness=219653
	g.bestAttackerInGeneration=4000
	g.bestAttackerFitness=-8192
	g.endGeneration
	*/
	int generation = 0;
	double parentPacketReceived_fitness = 0;
	double parentDataReady_fitness = 0;
	double parentPacketExpired_fitness = 0;
	int bestInGeneration = 0;
	double bestFitness = 0;
	double validatedFitness = 0;
	int bestAttackerInGeneration = 0;
	double bestAttackerFitness = 0;

	cout << "generation,fitness,bestFitness,validatedFitness,bestAttackerFitness,bestInGeneration,bestAttackerInGeneration" << endl;

	string line;
	while(getline(cin,line)) {
		if(line == "g.endGeneration") {
			// Print the current data
			cout << generation << "," << (parentPacketReceived_fitness+parentDataReady_fitness+parentPacketExpired_fitness)
					<< "," << bestFitness << "," << validatedFitness << "," << bestAttackerFitness << "," << bestInGeneration << "," << bestAttackerInGeneration << endl;
		} else {
			const char *start = line.c_str();
			const char *equalsSign = strchr(start,'=');
			if(equalsSign) {
				string prefix(start,equalsSign-start);
				if(prefix == "g.generation") {
					generation = atoi(equalsSign+1);
				} else if(prefix == "g.parentPacketReceived_fitness") {
					parentPacketReceived_fitness = atof(equalsSign+1);
				} else if(prefix == "g.parentDataReady_fitness") {
					parentDataReady_fitness = atof(equalsSign+1);
				} else if(prefix == "g.parentPacketExpired_fitness") {
					parentPacketExpired_fitness = atof(equalsSign+1);
				} else if(prefix == "g.bestFitness") {
					bestFitness = atof(equalsSign+1);
				} else if(prefix == "g.bestAttackerFitness") {
					bestAttackerFitness = atof(equalsSign+1);
				} else if(prefix == "g.validatedFitness") {
					validatedFitness = atof(equalsSign+1);
				} else if(prefix == "g.bestInGeneration") {
					bestInGeneration = atoi(equalsSign+1);
				} else if(prefix == "g.bestAttackerInGeneration") {
					bestAttackerInGeneration = atoi(equalsSign+1);
				}
			}
		}
	}
}

int main(int argc, char *argv[]) {
	makeFitnessCSV();
	return 0;
}
