#ifndef CGPGraphViz_H
#define CGPGraphViz_H

#include <fstream>
#include <vector>
#include "CGP.h"
using namespace CartesianGeneticProgramming;
using namespace std;

class CGPGraphViz {
public:
	static bool HandleCommandLine(int argc, char *argv[]);

public:
	CGPGraphViz();
	~CGPGraphViz();

	void Convert(const char *inputCGPFileName, const char *outputDottyFileName, const vector<string> &inputNames, const vector<string> &outputNames);
	void Create(CGPIndividual &program, const char *outputDottyFileName, const vector<string> &inputNames, const vector<string> &outputNames);
};

#endif
